from pprint import  pprint
from openmdao.api import Component
from parser_classes import AggregatedComp


def find_desvars(group):
    names = compnames(group)

    desvars = []
    for cname, c in names.items():
        if c.desvar:
            vname, default, min, max = c.desvar
            desvars.append(('{}.{}'.format(cname, vname), min, max))

    print(desvars)
    return desvars



def compnames(sys, rootname=''):
    names = {}
    for g in sys.subgroups():
        name = '{}{}.'.format(rootname, g.name)
        names.update(compnames(g, name))

    names.update({'{}{}'.format(rootname, c.name): c
                  for c in sys.subsystems(typ=AggregatedComp)})
    return names