joint_def_change='''
Z_ROT_DAMPER = 1;
Z_ROT_LOAD = 1;
Z_ROT_SPRING = 1;
Z_ROT_STATUS = SPRING_CONSTRAINED;
'''

new_defs='''

!*** Functions ***
ENGINE
{
BASE_ID = 36;
ID = 1;
MATH_FUNC = 1 FcfSCALE;
SENSOR = 1 FcTIME_SENSOR;
}
!*** Function definitions ***
FUNC_SCALE
{
FUNC_USE = GENERAL;
ID = 1;
SCALE = -6.28;
}
!*** Joint dampers ***
JOINT_DAMPER
{
BASE_ID = 40;
ID = 1;
INIT_DAMPING = 100;
IS_DEF_DAMPER = false;
}
!*** Joint springs ***
JOINT_SPRING
{
BASE_ID = 39;
ENGINE = 1;
ID = 1;
INIT_LENGTH = 0;
INIT_STIFFNESS = 5000;
USE_INIT_DEFLECTION = false;
}
!*** Loads ***
DOF_LOAD
{
BASE_ID = 38;
ID = 1;
INIT_LOAD = 0;
}

END {FEDEMMODELFILE}
'''

def add_motion(fmm_file, joint_ibd=19):

    at_joint = False
    contents = []

    with(open(fmm_file, 'r+')) as fd:
        for line in fd:

            if line.startswith('BASE_ID = {};'.format(joint_ibd)):
                print('found joint')
                at_joint = True

            if at_joint and line.startswith('Z_ROT_STATUS = FREE;'):
                contents.append(joint_def_change)
                at_joint = False
            else:
                contents.append(line)


        contents = contents[:-1]
        contents.append(new_defs)

        fd.seek(0)
        fd.truncate()
        fd.writelines(contents)