from openmdao.api import Problem, view_model

from yamlparser import parsefile
from file_writer import write_files
from Aml import FmmWriter
from fedem import Fedem

import time

aml = FmmWriter()

g, d = parsefile('four-bar.yaml')
prob = Problem(root=g)
prob.setup()
prob.run()
# view_connections(g)
#view_model(prob)

path = 'C:\\Users\\arnt\\Documents\\GitHub\\KBE\\library\\mechtimum-files\\out\\'
fmm_file = 'model.fmm'

write_files(prob['dict'], path=path)
aml.write_fmm()
time.sleep(1.0)
fedem = Fedem(path, fmm_file)
v = fedem.get_res_on_bid(9, 'Velocity:VEC3:Y', 'vel')
print(v)
aml.aml.end()
v.plot()

result = fedem.get_res_on_bid(9, 'Position matrix:TMAT34:Position X', 'x')
result.columns = ['x']
print(result.head())
not_of_interest = result.loc[lambda df: df.x < 0, :]
settle_time = not_of_interest.index[0]
print('OBJ:', settle_time)
fedem.end()
