import sexpdata
import yaml
from pprint import pprint

print_stuff = True
name = 'four-bar'

def listify(tree):
    if type(tree) == dict:
        #print('found dict')
        return [(sexpdata.Symbol(key), listify(val))
                for key, val in tree.items()]
    elif type(tree) == list:
        #print('found list')
        return [listify(val) for val in tree]
    else:
        #print()
        return tree

def f(d):
    out = sexpdata.dumps(listify(d))

    with open('sexp' + '.aml', 'w') as out_file:
        out_file.write(out)

if __name__=='__main__':
    with open(name+'.yaml', 'r') as f:
        data_tree = yaml.load(f)
        out = sexpdata.dumps(listify(data_tree))

        with open(name + '.aml', 'w') as out_file:
            out_file.write(out)

        if print_stuff:
            print(out)
            print('-'*100, '\n'*3)
            print(out.replace(')', ')\n'))
            print('\n'*3, '-'*100, '\n'*3)
            pprint(listify(data_tree))